import React, { useRef } from 'react';
import { a } from '@react-spring/three';
import { useClouds, useCloud } from './use-cloud';
export var DarkCloud = function DarkCloud(_ref) {
  var value = _ref.value,
      style = _ref.style;
  var cloud = useRef();
  useCloud(cloud);
  return /*#__PURE__*/React.createElement(a.mesh, {
    ref: cloud,
    "material-opacity": style === null || style === void 0 ? void 0 : style.opacity.to(function (x) {
      return x * value.opacity;
    }),
    position: value.startpoint
  }, /*#__PURE__*/React.createElement("circleBufferGeometry", {
    attach: "geometry",
    args: [value.radius, 128]
  }), /*#__PURE__*/React.createElement("meshBasicMaterial", {
    attach: "material",
    transparent: true,
    color: value.color
  }));
};

var Cloudy = function Cloudy(props) {
  var _a;

  var _useClouds = useClouds(props),
      clouds = _useClouds.clouds;

  var pY = (_a = props.style) === null || _a === void 0 ? void 0 : _a.opacity.to([0, 1], [2, 0]);
  return /*#__PURE__*/React.createElement(a.group, {
    "position-y": pY
  }, clouds.map(function (cloud, index) {
    return /*#__PURE__*/React.createElement(DarkCloud, {
      key: index,
      value: cloud,
      style: props.style
    });
  }));
};

export default Cloudy;
//# sourceMappingURL=index.js.map
