function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var __rest = this && this.__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

import React, { createContext, useState, useCallback, useContext, useEffect } from 'react';
import { Canvas, useFrame, useThree } from '@react-three/fiber';
import { Color } from 'three';
import { useSpring } from '@react-spring/three';
import { PerspectiveCamera } from '@react-three/drei';
import { useTheme } from '../hooks/use-theme';
import { FogCamera } from '../fog';
var WeatherContext = /*#__PURE__*/createContext({});

var Container = function Container(props) {
  var _useThree = useThree(),
      scene = _useThree.scene,
      camera = _useThree.camera;

  useFrame(function () {
    var _a, _b;

    scene.background = new Color((_a = props.style.backgroundColor) === null || _a === void 0 ? void 0 : _a.get());

    if (props.type !== 'fog' && ((_b = props.style.backgroundColor) === null || _b === void 0 ? void 0 : _b.idle)) {
      camera.lookAt(0, 0, 0);
      camera.position.z = 5;
    }
  });
  return /*#__PURE__*/React.createElement(React.Fragment, null, props.children);
};

export var WeatherProvider = function WeatherProvider(_a) {
  var _a$defaultMode = _a.defaultMode,
      defaultMode = _a$defaultMode === void 0 ? 'day' : _a$defaultMode,
      _a$defaultType = _a.defaultType,
      defaultType = _a$defaultType === void 0 ? 'sun' : _a$defaultType,
      props = __rest(_a, ["defaultMode", "defaultType"]);

  var _useState = useState(defaultType),
      _useState2 = _slicedToArray(_useState, 2),
      type = _useState2[0],
      setType = _useState2[1];

  var _useState3 = useState(defaultMode),
      _useState4 = _slicedToArray(_useState3, 2),
      mode = _useState4[0],
      setMode = _useState4[1];

  var controlType = props.type || type;
  var controlMode = props.mode || mode;

  var _useTheme = useTheme({
    type: controlType,
    mode: controlMode
  }),
      bind = _useTheme.bind;

  var _b = bind(),
      _style = _b.style,
      config = __rest(_b, ["style"]);

  var _useSpring = useSpring(function () {
    return {
      backgroundColor: _style.backgroundColor
    };
  }),
      _useSpring2 = _slicedToArray(_useSpring, 2),
      style = _useSpring2[0],
      api = _useSpring2[1];

  useEffect(function () {
    api.start({
      backgroundColor: _style.backgroundColor
    });
  }, [_style.backgroundColor, api]);
  var handleChangeType = useCallback(function (type) {
    setType(type);
  }, []);
  var handleChangeMode = useCallback(function (mode) {
    setMode(mode);
  }, []);
  return /*#__PURE__*/React.createElement(WeatherContext.Provider, {
    value: {
      type: controlType,
      mode: controlMode,
      handleChangeType: handleChangeType,
      handleChangeMode: handleChangeMode
    }
  }, props.extra, /*#__PURE__*/React.createElement(Canvas, Object.assign({}, config), type === 'fog' ? /*#__PURE__*/React.createElement(FogCamera, null) : /*#__PURE__*/React.createElement(PerspectiveCamera, {
    makeDefault: true,
    args: [75, 0, 0.1, 1000]
  }), /*#__PURE__*/React.createElement(Container, {
    type: controlType,
    style: style
  }, props.children)));
};
export var useWeather = function useWeather() {
  return useContext(WeatherContext);
};
export var WeatherConsumer = WeatherContext.Consumer;
//# sourceMappingURL=context.js.map
