import React, { useRef } from 'react';
import { extend } from '@react-three/fiber';
import { MeshLine, MeshLineMaterial } from 'three.meshline';
import { a } from '@react-spring/three';
import { useHazeDrop, useHaze } from './use-haze';
extend({
  MeshLine: MeshLine,
  MeshLineMaterial: MeshLineMaterial
});
export var Haze = function Haze(props) {
  var _a;

  var haze = useRef();
  var mat = useRef();
  useHazeDrop(haze, mat, {
    value: props.value
  });
  return /*#__PURE__*/React.createElement(a.mesh, {
    ref: haze,
    "material-opacity": (_a = props.style) === null || _a === void 0 ? void 0 : _a.opacity.to(function (x) {
      return x * props.value.opacity;
    })
  }, /*#__PURE__*/React.createElement("meshLine", {
    attach: "geometry",
    vertices: props.value.vertices
  }), /*#__PURE__*/React.createElement("meshLineMaterial", {
    attach: "material",
    ref: mat,
    transparent: true,
    depthTest: false,
    sizeAttenuation: true,
    lineWidth: 0.01,
    dashArray: props.value.dashArray,
    dashRatio: 0.8,
    color: props.value.color
  }));
};

var Hazes = function Hazes(props) {
  var _useHaze = useHaze(props),
      lines = _useHaze.lines;

  return /*#__PURE__*/React.createElement(a.group, null, lines.map(function (haze, index) {
    return /*#__PURE__*/React.createElement(Haze, {
      key: index,
      value: haze,
      style: props.style
    });
  }));
};

export default Hazes;
//# sourceMappingURL=index.js.map
