import { useCallback, useMemo } from 'react';
import { dayTheme, nightTheme } from '../theme';
var theme = {
  day: dayTheme,
  night: nightTheme
};
export var useTheme = function useTheme(_ref) {
  var _ref$mode = _ref.mode,
      mode = _ref$mode === void 0 ? 'day' : _ref$mode,
      type = _ref.type;
  var config = useMemo(function () {
    return theme[mode][type];
  }, [mode, type]);
  var bind = useCallback(function () {
    return Object.assign(Object.assign({}, config), {
      dpr: window.devicePixelRatio
    });
  }, [config]);
  return {
    bind: bind
  };
};
//# sourceMappingURL=use-theme.js.map
