import React, { useRef } from 'react';
import { extend } from '@react-three/fiber';
import { a } from '@react-spring/three';
import { MeshLine, MeshLineMaterial } from 'three.meshline';
import { useMeteors, useMeteor } from './use-meteors';
extend({
  MeshLine: MeshLine,
  MeshLineMaterial: MeshLineMaterial
});

var Meteor = function Meteor(_ref) {
  var value = _ref.value,
      style = _ref.style;
  var meteor = useRef();
  var mat = useRef();
  useMeteor(meteor, mat, {
    value: value
  });
  return /*#__PURE__*/React.createElement(a.mesh, {
    ref: meteor,
    "material-opacity": style === null || style === void 0 ? void 0 : style.opacity.to(function (x) {
      return x * 0.75;
    })
  }, /*#__PURE__*/React.createElement("meshLine", {
    attach: "geometry",
    vertices: value.vertices
  }), /*#__PURE__*/React.createElement("meshLineMaterial", {
    attach: "material",
    ref: mat,
    transparent: true,
    depthTest: false,
    sizeAttenuation: true,
    lineWidth: 0.02,
    dashArray: 0.5,
    dashRatio: 0.7,
    color: value.color
  }));
};

var Meteors = function Meteors(props) {
  var _useMeteors = useMeteors(props),
      meteors = _useMeteors.meteors;

  return /*#__PURE__*/React.createElement(React.Fragment, null, meteors.map(function (meteor, index) {
    return /*#__PURE__*/React.createElement(Meteor, {
      key: index,
      value: meteor,
      style: props.style
    });
  }));
};

export default Meteors;
//# sourceMappingURL=index.js.map
