import React, { useRef } from 'react';
import { a } from '@react-spring/three';
import { usePartlyClouds, usePartlyCloud } from './use-partly-cloud';
export var WhiteCloud = function WhiteCloud(_ref) {
  var value = _ref.value,
      style = _ref.style;
  var cloud = useRef();
  usePartlyCloud(cloud);
  return /*#__PURE__*/React.createElement(a.mesh, {
    "material-opacity": style === null || style === void 0 ? void 0 : style.opacity.to(function (x) {
      return x * value.opacity;
    }),
    ref: cloud,
    position: value.startpoint
  }, /*#__PURE__*/React.createElement("circleBufferGeometry", {
    attach: "geometry",
    args: [value.radius, 128]
  }), /*#__PURE__*/React.createElement("meshBasicMaterial", {
    attach: "material",
    transparent: true,
    color: value.color
  }));
};

var PartlyCloudy = function PartlyCloudy(props) {
  var _a;

  var _usePartlyClouds = usePartlyClouds(props),
      clouds = _usePartlyClouds.clouds;

  var pY = (_a = props.style) === null || _a === void 0 ? void 0 : _a.opacity.to([0, 1], [2, 0]);
  return /*#__PURE__*/React.createElement(a.group, {
    "position-y": pY
  }, clouds.map(function (cloud, index) {
    return /*#__PURE__*/React.createElement(WhiteCloud, {
      key: index,
      value: cloud,
      style: props.style
    });
  }));
};

export default PartlyCloudy;
//# sourceMappingURL=index.js.map
