import React, { useRef } from 'react';
import { useRainRing, useRainRings } from './use-rain-ring';
export var RainRing = function RainRing(_ref) {
  var value = _ref.value,
      style = _ref.style;
  var mesh = useRef();
  useRainRing(mesh, {
    style: style
  });
  return /*#__PURE__*/React.createElement("mesh", {
    ref: mesh,
    scale: [0, 0, 0],
    position: value.startpoint
  }, /*#__PURE__*/React.createElement("circleGeometry", {
    attach: "geometry",
    args: [value.radius, 128]
  }), /*#__PURE__*/React.createElement("meshBasicMaterial", {
    attach: "material",
    opacity: 0.2,
    transparent: true,
    color: "white"
  }));
};

var RainRings = function RainRings(props) {
  var _useRainRings = useRainRings(props),
      rings = _useRainRings.rings;

  return /*#__PURE__*/React.createElement(React.Fragment, null, rings.map(function (ring, index) {
    return /*#__PURE__*/React.createElement(RainRing, {
      key: index,
      value: ring,
      style: props.style
    });
  }));
};

export default RainRings;
//# sourceMappingURL=index.js.map
