import { useRain, useRaindrop } from './use-rain';
import React, { useRef } from 'react';
import { a } from '@react-spring/three';
import { extend } from '@react-three/fiber';
import { MeshLine, MeshLineMaterial } from 'three.meshline';
extend({
  MeshLine: MeshLine,
  MeshLineMaterial: MeshLineMaterial
});
export var Raindrop = function Raindrop(props) {
  var raindrop = useRef();
  var mat = useRef();
  useRaindrop(raindrop, mat, {
    value: props.value,
    style: props.style
  });
  return /*#__PURE__*/React.createElement("mesh", {
    ref: raindrop
  }, /*#__PURE__*/React.createElement("meshLine", {
    attach: "geometry",
    vertices: props.value.vertices
  }), /*#__PURE__*/React.createElement("meshLineMaterial", {
    attach: "material",
    ref: mat,
    transparent: true,
    depthTest: false,
    sizeAttenuation: true,
    lineWidth: 0.01,
    opacity: 0,
    color: props.value.color
  }));
};

var Rain = function Rain(props) {
  var _useRain = useRain(props),
      lines = _useRain.lines;

  return /*#__PURE__*/React.createElement(a.group, null, lines.map(function (raindrop, index) {
    return /*#__PURE__*/React.createElement(Raindrop, {
      key: index,
      value: raindrop,
      style: props.style
    });
  }));
};

export default Rain;
//# sourceMappingURL=index.js.map
