import * as THREE from 'three';
import React from 'react';
import { Style } from '../interface';
export declare type Raindrop = {
    vertices: THREE.Vector3[];
    orientation: 'fromRight' | 'fromTop' | 'fromLeft';
    leg: number;
    angle: number;
    color: string;
};
export declare type UseRainProps = {
    count?: number;
    angle?: number;
    colors?: string[];
};
export declare const DEFAULT_RAINPROPS: {
    count: number;
    angle: number;
};
export declare const useRain: ({ angle, count, colors, }?: UseRainProps) => {
    lines: Raindrop[];
};
export declare type UseRaindropProps = {
    value: Raindrop;
    style?: Style;
};
export declare const useRaindrop: (raindrop: React.MutableRefObject<THREE.Mesh | undefined>, mat: React.MutableRefObject<any>, props?: UseRaindropProps | undefined) => void;
