import React, { useRef } from 'react';
import { a } from '@react-spring/three';
import { useSnowflakes, useSnowflake } from './use-snowflake';

var SnowFlake = function SnowFlake(_ref) {
  var value = _ref.value,
      style = _ref.style;
  var flake = useRef();
  useSnowflake(flake, {
    value: value
  });
  return /*#__PURE__*/React.createElement(a.mesh, {
    position: value.startpoint,
    ref: flake,
    "material-opacity": style === null || style === void 0 ? void 0 : style.opacity
  }, /*#__PURE__*/React.createElement("circleGeometry", {
    attach: "geometry",
    args: [value.radius, 128]
  }), /*#__PURE__*/React.createElement("meshBasicMaterial", {
    color: "white",
    transparent: true,
    attach: "material"
  }));
};

var Snow = function Snow(props) {
  var _useSnowflakes = useSnowflakes(props),
      snowflakes = _useSnowflakes.snowflakes;

  return /*#__PURE__*/React.createElement(a.group, null, snowflakes.map(function (snowflake, index) {
    return /*#__PURE__*/React.createElement(SnowFlake, {
      key: index,
      value: snowflake,
      style: props.style
    });
  }));
};

export default Snow;
//# sourceMappingURL=index.js.map
