import { useStarRings, useRing } from './use-starrings';
import React, { useRef } from 'react';
import { extend } from '@react-three/fiber';
import { a } from '@react-spring/three';
import { MeshLine, MeshLineMaterial } from 'three.meshline';
extend({
  MeshLine: MeshLine,
  MeshLineMaterial: MeshLineMaterial
});

var Ring = function Ring(_ref) {
  var value = _ref.value,
      style = _ref.style;
  var ring = useRef();
  useRing(ring);
  return /*#__PURE__*/React.createElement(a.mesh, {
    "material-opacity": style === null || style === void 0 ? void 0 : style.opacity.to(function (x) {
      return x * value.opacity;
    })
  }, /*#__PURE__*/React.createElement("meshLine", {
    attach: "geometry",
    vertices: value.vertices
  }), /*#__PURE__*/React.createElement("meshLineMaterial", {
    ref: ring,
    attach: "material",
    transparent: true,
    depthTest: false,
    sizeAttenuation: true,
    dashArray: value.dashArray,
    dashRatio: 0.2,
    lineWidth: value.lineWidth,
    color: value.color
  }));
};

var StarRings = function StarRings(props) {
  var _useStarRings = useStarRings(props),
      rings = _useStarRings.rings,
      startpoint = _useStarRings.startpoint;

  return /*#__PURE__*/React.createElement(a.group, {
    position: startpoint
  }, rings.map(function (ring, index) {
    return /*#__PURE__*/React.createElement(Ring, {
      key: index,
      value: ring,
      style: props.style
    });
  }));
};

export default StarRings;
//# sourceMappingURL=index.js.map
