import React, { useRef } from 'react';
import { useFrame } from '@react-three/fiber';
import { a } from '@react-spring/three';
import { useSun } from './use-sun';
import { inRange } from '../utils/random';
import { DIRS } from '../utils/constants';

var SunHalo = function SunHalo(_ref) {
  var value = _ref.value,
      style = _ref.style;
  var dir = useRef(1);
  var speed = useRef(Math.random() * 0.0001 * inRange(DIRS));
  var halo = useRef();
  useFrame(function () {
    if (!halo.current) {
      return;
    }

    if (halo.current.scale.x <= 0.9) {
      dir.current = -dir.current;
    } else if (halo.current.scale.x >= 1.1) {
      dir.current = -dir.current;
    }

    halo.current.scale.x += speed.current * dir.current;
    halo.current.scale.y += speed.current * dir.current;
  });
  return /*#__PURE__*/React.createElement(a.mesh, {
    ref: halo,
    "material-opacity": style === null || style === void 0 ? void 0 : style.opacity,
    position: value.startpoint
  }, /*#__PURE__*/React.createElement("circleGeometry", {
    attach: "geometry",
    args: [value.radius, 128]
  }), /*#__PURE__*/React.createElement("meshBasicMaterial", {
    attach: "material",
    transparent: true,
    color: value.color
  }));
};

var Sun = function Sun(props) {
  var _a;

  var sun = useRef();

  var _useSun = useSun(props),
      halos = _useSun.halos,
      startpoint = _useSun.startpoint;

  return /*#__PURE__*/React.createElement(a.group, {
    scale: (_a = props.style) === null || _a === void 0 ? void 0 : _a.scale,
    ref: sun,
    position: startpoint
  }, halos.map(function (halo, index) {
    return /*#__PURE__*/React.createElement(SunHalo, {
      key: index,
      value: halo,
      style: props.style
    });
  }));
};

export default Sun;
//# sourceMappingURL=index.js.map
