import { useRef, useMemo } from 'react';
import { useFrame } from '@react-three/fiber';
import { Vector3 } from 'three';
import { getCoord } from '../utils/scene';
var R = 2;
var HALO_COLORS = ['#faf3d2', '#fbebb3', '#fae09c', '#f9d67c', '#f6c451', '#c34e35'];
export var useSun = function useSun() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {
    percentX: 1,
    count: HALO_COLORS.length
  },
      _ref$percentX = _ref.percentX,
      percentX = _ref$percentX === void 0 ? 1 : _ref$percentX,
      _ref$count = _ref.count,
      count = _ref$count === void 0 ? HALO_COLORS.length : _ref$count;

  var angle = useRef(-(Math.random() * 90 + 90));
  var coord = useRef(getCoord()).current;
  var startpoint = useMemo(function () {
    return new Vector3(coord[0] * percentX, coord[1], 0);
  }, [coord, percentX]);
  var sunshines = useMemo(function () {
    return Array(3).fill(0).map(function (_v, i) {
      angle.current += i * 20;
      var startpoint = Math.random() * coord[0] + coord[0] * percentX;
      var length = Math.random() * 2;
      return {
        vertices: [new Vector3(Math.cos(angle.current * Math.PI / 180) * startpoint, Math.sin(angle.current * Math.PI / 180) * startpoint, 0), new Vector3(Math.cos(angle.current * Math.PI / 180) * (startpoint + length), Math.sin(angle.current * Math.PI / 180) * (startpoint + length), 0)],
        angle: angle.current
      };
    });
  }, [coord, percentX]);
  var halos = useMemo(function () {
    return Array(count).fill(0).map(function (_v, i) {
      var startpoint = new Vector3(0.5 - Math.random() * 1, 0.5 - Math.random() * 1, 0);
      return {
        radius: R + 5 - i,
        color: HALO_COLORS[i],
        startpoint: startpoint
      };
    });
  }, [count]);
  return {
    sunshines: sunshines,
    halos: halos,
    startpoint: startpoint
  };
};
export var useSunshine = function useSunshine(sunshine) {
  useFrame(function () {
    if (!sunshine.current) {
      return;
    }

    sunshine.current.rotation.z -= 0.001;

    if (Math.abs(sunshine.current.rotation.z) > 2) {
      sunshine.current.rotation.z = 0;
    }
  });
};
//# sourceMappingURL=use-sun.js.map
