"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.WeatherConsumer = exports.useWeather = exports.WeatherProvider = void 0;

var _react = _interopRequireWildcard(require("react"));

var _fiber = require("@react-three/fiber");

var _three = require("three");

var _three2 = require("@react-spring/three");

var _drei = require("@react-three/drei");

var _useTheme2 = require("../hooks/use-theme");

var _fog = require("../fog");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

var WeatherContext = /*#__PURE__*/(0, _react.createContext)({});

var Container = function Container(props) {
  var _useThree = (0, _fiber.useThree)(),
      scene = _useThree.scene,
      camera = _useThree.camera;

  (0, _fiber.useFrame)(function () {
    var _a, _b;

    scene.background = new _three.Color((_a = props.style.backgroundColor) === null || _a === void 0 ? void 0 : _a.get());

    if (props.type !== 'fog' && ((_b = props.style.backgroundColor) === null || _b === void 0 ? void 0 : _b.idle)) {
      camera.lookAt(0, 0, 0);
      camera.position.z = 5;
    }
  });
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, props.children);
};

var WeatherProvider = function WeatherProvider(_a) {
  var _a$defaultMode = _a.defaultMode,
      defaultMode = _a$defaultMode === void 0 ? 'day' : _a$defaultMode,
      _a$defaultType = _a.defaultType,
      defaultType = _a$defaultType === void 0 ? 'sun' : _a$defaultType,
      props = __rest(_a, ["defaultMode", "defaultType"]);

  var _useState = (0, _react.useState)(defaultType),
      _useState2 = _slicedToArray(_useState, 2),
      type = _useState2[0],
      setType = _useState2[1];

  var _useState3 = (0, _react.useState)(defaultMode),
      _useState4 = _slicedToArray(_useState3, 2),
      mode = _useState4[0],
      setMode = _useState4[1];

  var controlType = props.type || type;
  var controlMode = props.mode || mode;

  var _useTheme = (0, _useTheme2.useTheme)({
    type: controlType,
    mode: controlMode
  }),
      bind = _useTheme.bind;

  var _b = bind(),
      _style = _b.style,
      config = __rest(_b, ["style"]);

  var _useSpring = (0, _three2.useSpring)(function () {
    return {
      backgroundColor: _style.backgroundColor
    };
  }),
      _useSpring2 = _slicedToArray(_useSpring, 2),
      style = _useSpring2[0],
      api = _useSpring2[1];

  (0, _react.useEffect)(function () {
    api.start({
      backgroundColor: _style.backgroundColor
    });
  }, [_style.backgroundColor, api]);
  var handleChangeType = (0, _react.useCallback)(function (type) {
    setType(type);
  }, []);
  var handleChangeMode = (0, _react.useCallback)(function (mode) {
    setMode(mode);
  }, []);
  return /*#__PURE__*/_react.default.createElement(WeatherContext.Provider, {
    value: {
      type: controlType,
      mode: controlMode,
      handleChangeType: handleChangeType,
      handleChangeMode: handleChangeMode
    }
  }, props.extra, /*#__PURE__*/_react.default.createElement(_fiber.Canvas, Object.assign({}, config), type === 'fog' ? /*#__PURE__*/_react.default.createElement(_fog.FogCamera, null) : /*#__PURE__*/_react.default.createElement(_drei.PerspectiveCamera, {
    makeDefault: true,
    args: [75, 0, 0.1, 1000]
  }), /*#__PURE__*/_react.default.createElement(Container, {
    type: controlType,
    style: style
  }, props.children)));
};

exports.WeatherProvider = WeatherProvider;

var useWeather = function useWeather() {
  return (0, _react.useContext)(WeatherContext);
};

exports.useWeather = useWeather;
var WeatherConsumer = WeatherContext.Consumer;
exports.WeatherConsumer = WeatherConsumer;
//# sourceMappingURL=context.js.map
