"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.Haze = void 0;

var _react = _interopRequireWildcard(require("react"));

var _fiber = require("@react-three/fiber");

var _three = require("three.meshline");

var _three2 = require("@react-spring/three");

var _useHaze2 = require("./use-haze");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

(0, _fiber.extend)({
  MeshLine: _three.MeshLine,
  MeshLineMaterial: _three.MeshLineMaterial
});

var Haze = function Haze(props) {
  var _a;

  var haze = (0, _react.useRef)();
  var mat = (0, _react.useRef)();
  (0, _useHaze2.useHazeDrop)(haze, mat, {
    value: props.value
  });
  return /*#__PURE__*/_react.default.createElement(_three2.a.mesh, {
    ref: haze,
    "material-opacity": (_a = props.style) === null || _a === void 0 ? void 0 : _a.opacity.to(function (x) {
      return x * props.value.opacity;
    })
  }, /*#__PURE__*/_react.default.createElement("meshLine", {
    attach: "geometry",
    vertices: props.value.vertices
  }), /*#__PURE__*/_react.default.createElement("meshLineMaterial", {
    attach: "material",
    ref: mat,
    transparent: true,
    depthTest: false,
    sizeAttenuation: true,
    lineWidth: 0.01,
    dashArray: props.value.dashArray,
    dashRatio: 0.8,
    color: props.value.color
  }));
};

exports.Haze = Haze;

var Hazes = function Hazes(props) {
  var _useHaze = (0, _useHaze2.useHaze)(props),
      lines = _useHaze.lines;

  return /*#__PURE__*/_react.default.createElement(_three2.a.group, null, lines.map(function (haze, index) {
    return /*#__PURE__*/_react.default.createElement(Haze, {
      key: index,
      value: haze,
      style: props.style
    });
  }));
};

var _default = Hazes;
exports.default = _default;
//# sourceMappingURL=index.js.map
