"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useTheme = void 0;

var _react = require("react");

var _theme = require("../theme");

var theme = {
  day: _theme.dayTheme,
  night: _theme.nightTheme
};

var useTheme = function useTheme(_ref) {
  var _ref$mode = _ref.mode,
      mode = _ref$mode === void 0 ? 'day' : _ref$mode,
      type = _ref.type;
  var config = (0, _react.useMemo)(function () {
    return theme[mode][type];
  }, [mode, type]);
  var bind = (0, _react.useCallback)(function () {
    return Object.assign(Object.assign({}, config), {
      dpr: window.devicePixelRatio
    });
  }, [config]);
  return {
    bind: bind
  };
};

exports.useTheme = useTheme;
//# sourceMappingURL=use-theme.js.map
