"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useTransition = void 0;

var _core = require("@react-spring/core");

var useTransition = function useTransition(props) {
  var transition = (0, _core.useTransition)(props.location, {
    from: {
      opacity: 0,
      scale: [0, 0, 0]
    },
    enter: {
      opacity: 1,
      scale: [1, 1, 1]
    },
    leave: {
      opacity: 0,
      scale: [0, 0, 0]
    }
  });
  return {
    transition: transition
  };
};

exports.useTransition = useTransition;
//# sourceMappingURL=use-transition.js.map
