"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.WhiteCloud = void 0;

var _react = _interopRequireWildcard(require("react"));

var _three = require("@react-spring/three");

var _usePartlyCloud = require("./use-partly-cloud");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var WhiteCloud = function WhiteCloud(_ref) {
  var value = _ref.value,
      style = _ref.style;
  var cloud = (0, _react.useRef)();
  (0, _usePartlyCloud.usePartlyCloud)(cloud);
  return /*#__PURE__*/_react.default.createElement(_three.a.mesh, {
    "material-opacity": style === null || style === void 0 ? void 0 : style.opacity.to(function (x) {
      return x * value.opacity;
    }),
    ref: cloud,
    position: value.startpoint
  }, /*#__PURE__*/_react.default.createElement("circleBufferGeometry", {
    attach: "geometry",
    args: [value.radius, 128]
  }), /*#__PURE__*/_react.default.createElement("meshBasicMaterial", {
    attach: "material",
    transparent: true,
    color: value.color
  }));
};

exports.WhiteCloud = WhiteCloud;

var PartlyCloudy = function PartlyCloudy(props) {
  var _a;

  var _usePartlyClouds = (0, _usePartlyCloud.usePartlyClouds)(props),
      clouds = _usePartlyClouds.clouds;

  var pY = (_a = props.style) === null || _a === void 0 ? void 0 : _a.opacity.to([0, 1], [2, 0]);
  return /*#__PURE__*/_react.default.createElement(_three.a.group, {
    "position-y": pY
  }, clouds.map(function (cloud, index) {
    return /*#__PURE__*/_react.default.createElement(WhiteCloud, {
      key: index,
      value: cloud,
      style: props.style
    });
  }));
};

var _default = PartlyCloudy;
exports.default = _default;
//# sourceMappingURL=index.js.map
