"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _useStarrings = require("./use-starrings");

var _react = _interopRequireWildcard(require("react"));

var _fiber = require("@react-three/fiber");

var _three = require("@react-spring/three");

var _three2 = require("three.meshline");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

(0, _fiber.extend)({
  MeshLine: _three2.MeshLine,
  MeshLineMaterial: _three2.MeshLineMaterial
});

var Ring = function Ring(_ref) {
  var value = _ref.value,
      style = _ref.style;
  var ring = (0, _react.useRef)();
  (0, _useStarrings.useRing)(ring);
  return /*#__PURE__*/_react.default.createElement(_three.a.mesh, {
    "material-opacity": style === null || style === void 0 ? void 0 : style.opacity.to(function (x) {
      return x * value.opacity;
    })
  }, /*#__PURE__*/_react.default.createElement("meshLine", {
    attach: "geometry",
    vertices: value.vertices
  }), /*#__PURE__*/_react.default.createElement("meshLineMaterial", {
    ref: ring,
    attach: "material",
    transparent: true,
    depthTest: false,
    sizeAttenuation: true,
    dashArray: value.dashArray,
    dashRatio: 0.2,
    lineWidth: value.lineWidth,
    color: value.color
  }));
};

var StarRings = function StarRings(props) {
  var _useStarRings = (0, _useStarrings.useStarRings)(props),
      rings = _useStarRings.rings,
      startpoint = _useStarRings.startpoint;

  return /*#__PURE__*/_react.default.createElement(_three.a.group, {
    position: startpoint
  }, rings.map(function (ring, index) {
    return /*#__PURE__*/_react.default.createElement(Ring, {
      key: index,
      value: ring,
      style: props.style
    });
  }));
};

var _default = StarRings;
exports.default = _default;
//# sourceMappingURL=index.js.map
