"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useRing = exports.useStarRings = void 0;

var _react = require("react");

var THREE = _interopRequireWildcard(require("three"));

var _random = _interopRequireDefault(require("../utils/random"));

var _constants = require("../utils/constants");

var _fiber = require("@react-three/fiber");

var _scene = require("../utils/scene");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var RING_COLORS = ['#cdd1d3', '#fcd337', '#1677b3'];

var useStarRings = function useStarRings() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {
    count: 50
  },
      _ref$count = _ref.count,
      count = _ref$count === void 0 ? 50 : _ref$count;

  var coord = (0, _react.useRef)((0, _scene.getCoord)()).current;
  var startpoint = (0, _react.useMemo)(function () {
    return new THREE.Vector3(-coord[0], coord[1], 0);
  }, [coord]);
  var rings = (0, _react.useMemo)(function () {
    return new Array(count).fill(0).map(function () {
      var radius = Math.random() * 10;
      var vertices = new Array(180).fill(0).map(function (_v, i) {
        return new THREE.Vector3(Math.cos(i * 2 * Math.PI / 180) * radius, Math.sin(i * 2 * Math.PI / 180) * radius, 0);
      });
      return {
        radius: radius,
        vertices: vertices,
        dashArray: Math.random() + 0.1,
        opacity: Math.random() * 0.8,
        color: _random.default.inRange(RING_COLORS),
        lineWidth: Math.random() * 0.05
      };
    });
  }, [count]);
  return {
    rings: rings,
    startpoint: startpoint
  };
};

exports.useStarRings = useStarRings;

var useRing = function useRing(ring) {
  var dir = _random.default.inRange(_constants.DIRS);

  var speed = (0, _react.useRef)(Math.random() * 2 * 0.0001);
  (0, _fiber.useFrame)(function () {
    if (!ring.current) {
      return;
    }

    ring.current.uniforms.dashOffset.value -= speed.current * dir;
  });
};

exports.useRing = useRing;
//# sourceMappingURL=use-starrings.js.map
