"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _fiber = require("@react-three/fiber");

var _three = require("@react-spring/three");

var _useSun2 = require("./use-sun");

var _random = require("../utils/random");

var _constants = require("../utils/constants");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var SunHalo = function SunHalo(_ref) {
  var value = _ref.value,
      style = _ref.style;
  var dir = (0, _react.useRef)(1);
  var speed = (0, _react.useRef)(Math.random() * 0.0001 * (0, _random.inRange)(_constants.DIRS));
  var halo = (0, _react.useRef)();
  (0, _fiber.useFrame)(function () {
    if (!halo.current) {
      return;
    }

    if (halo.current.scale.x <= 0.9) {
      dir.current = -dir.current;
    } else if (halo.current.scale.x >= 1.1) {
      dir.current = -dir.current;
    }

    halo.current.scale.x += speed.current * dir.current;
    halo.current.scale.y += speed.current * dir.current;
  });
  return /*#__PURE__*/_react.default.createElement(_three.a.mesh, {
    ref: halo,
    "material-opacity": style === null || style === void 0 ? void 0 : style.opacity,
    position: value.startpoint
  }, /*#__PURE__*/_react.default.createElement("circleGeometry", {
    attach: "geometry",
    args: [value.radius, 128]
  }), /*#__PURE__*/_react.default.createElement("meshBasicMaterial", {
    attach: "material",
    transparent: true,
    color: value.color
  }));
};

var Sun = function Sun(props) {
  var _a;

  var sun = (0, _react.useRef)();

  var _useSun = (0, _useSun2.useSun)(props),
      halos = _useSun.halos,
      startpoint = _useSun.startpoint;

  return /*#__PURE__*/_react.default.createElement(_three.a.group, {
    scale: (_a = props.style) === null || _a === void 0 ? void 0 : _a.scale,
    ref: sun,
    position: startpoint
  }, halos.map(function (halo, index) {
    return /*#__PURE__*/_react.default.createElement(SunHalo, {
      key: index,
      value: halo,
      style: props.style
    });
  }));
};

var _default = Sun;
exports.default = _default;
//# sourceMappingURL=index.js.map
