"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useSunshine = exports.useSun = void 0;

var _react = require("react");

var _fiber = require("@react-three/fiber");

var _three = require("three");

var _scene = require("../utils/scene");

var R = 2;
var HALO_COLORS = ['#faf3d2', '#fbebb3', '#fae09c', '#f9d67c', '#f6c451', '#c34e35'];

var useSun = function useSun() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {
    percentX: 1,
    count: HALO_COLORS.length
  },
      _ref$percentX = _ref.percentX,
      percentX = _ref$percentX === void 0 ? 1 : _ref$percentX,
      _ref$count = _ref.count,
      count = _ref$count === void 0 ? HALO_COLORS.length : _ref$count;

  var angle = (0, _react.useRef)(-(Math.random() * 90 + 90));
  var coord = (0, _react.useRef)((0, _scene.getCoord)()).current;
  var startpoint = (0, _react.useMemo)(function () {
    return new _three.Vector3(coord[0] * percentX, coord[1], 0);
  }, [coord, percentX]);
  var sunshines = (0, _react.useMemo)(function () {
    return Array(3).fill(0).map(function (_v, i) {
      angle.current += i * 20;
      var startpoint = Math.random() * coord[0] + coord[0] * percentX;
      var length = Math.random() * 2;
      return {
        vertices: [new _three.Vector3(Math.cos(angle.current * Math.PI / 180) * startpoint, Math.sin(angle.current * Math.PI / 180) * startpoint, 0), new _three.Vector3(Math.cos(angle.current * Math.PI / 180) * (startpoint + length), Math.sin(angle.current * Math.PI / 180) * (startpoint + length), 0)],
        angle: angle.current
      };
    });
  }, [coord, percentX]);
  var halos = (0, _react.useMemo)(function () {
    return Array(count).fill(0).map(function (_v, i) {
      var startpoint = new _three.Vector3(0.5 - Math.random() * 1, 0.5 - Math.random() * 1, 0);
      return {
        radius: R + 5 - i,
        color: HALO_COLORS[i],
        startpoint: startpoint
      };
    });
  }, [count]);
  return {
    sunshines: sunshines,
    halos: halos,
    startpoint: startpoint
  };
};

exports.useSun = useSun;

var useSunshine = function useSunshine(sunshine) {
  (0, _fiber.useFrame)(function () {
    if (!sunshine.current) {
      return;
    }

    sunshine.current.rotation.z -= 0.001;

    if (Math.abs(sunshine.current.rotation.z) > 2) {
      sunshine.current.rotation.z = 0;
    }
  });
};

exports.useSunshine = useSunshine;
//# sourceMappingURL=use-sun.js.map
