"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.PLACEMENTS = exports.PLACEMENT_TO_DIR = void 0;

var _point = _interopRequireDefault(require("./point"));

var _three = require("three");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PLACEMENT_TO_AXIS = {
  fromTop: 'x',
  fromRight: 'y',
  fromLeft: 'y',
  fromBottom: 'x'
};
var PLACEMENT_TO_DIR = {
  fromTop: 1,
  fromRight: 1,
  fromLeft: -1,
  fromBottom: -1
};
exports.PLACEMENT_TO_DIR = PLACEMENT_TO_DIR;
var PLACEMENTS = Object.keys(PLACEMENT_TO_DIR);
/**
 * 得到一个随机的噪声向量, 和orientation有关。
 * - placement = top -> [a, b, 0](fromPlacement) or [0, b, 0](fromAxis)
 * - placement = left -> [a, b, 0] or [a, 0, 0]
 * - placement = right -> [a, b, 0] or [a, 0, 0]
 * @param {Orientation} placement
 * @param props
 */

exports.PLACEMENTS = PLACEMENTS;

var fromAxis = function fromAxis(placement) {
  var endpoint = {
    x: 0,
    y: 0,
    z: 0
  };
  endpoint[PLACEMENT_TO_AXIS[placement]] = _point.default.fromAxis(PLACEMENT_TO_AXIS[placement]);
  return new _three.Vector3(endpoint.x, endpoint.z, endpoint.z);
};

var fromPlacement = function fromPlacement(placement) {
  var endpoint = {
    x: 0,
    y: 0,
    z: 0
  };
  endpoint[PLACEMENT_TO_AXIS[placement]] = _point.default.fromAxis(PLACEMENT_TO_AXIS[placement]);

  if (PLACEMENT_TO_AXIS[placement] === 'x') {
    endpoint.y = Math.abs(_point.default.fromAxisY() * 0.5) * PLACEMENT_TO_DIR[placement];
  }

  if (PLACEMENT_TO_AXIS[placement] === 'y') {
    endpoint.x = Math.abs(_point.default.fromAxisY() * 0.5) * PLACEMENT_TO_DIR[placement];
  }

  return new _three.Vector3(endpoint.x, endpoint.y, endpoint.z);
};

var random = function random() {
  return new _three.Vector3(_point.default.fromAxisX(), _point.default.fromAxisY(), _point.default.fromAxisZ());
};

var _default = {
  fromAxis: fromAxis,
  fromPlacement: fromPlacement,
  random: random
};
exports.default = _default;
//# sourceMappingURL=vertority.js.map
